//-----------------------------------------------------------------------------
// Routines d'affichage sur l'ecran LCD du Nokia 3310+Speaker/LED
// transmission par SPI
// dsPIC 30F3010
// L. BAGHLI 06/02/2008
//-----------------------------------------------------------------------------
#include "p30F3010.h"
#include "lcd3310.h"

//unsigned int HPHalfDUTY;

//-----------------------------------------------------------------------------
//	Config Haut parleur de l'ecran LCD via PWM 50%  freq variable
//-----------------------------------------------------------------------------
//void InitPWM_HP_LCD3310()
//{
//	HPHalfDUTY=T_1000Hz;	// la frequence est variable !
//	PTPER = HPHalfDUTY;		// set the pwm period register, ne pas oublier la double prcision
//	PWMCON1 = 0x0740;		// enable PWMs tt le tps
//	PDC3=HPHalfDUTY;			// init sans rien, apres une regul a change
//	OVDCON = 0xFFFF;	// Cmde MLI, no effect of OVDCON
//	PWMCON2 = 0x0000;		// 1 PWM values
//	PTCON = 0x8002;			// start PWM symetrique
//}
//-----------------------------------------------------------------------------
//	Init SPI du LCD
//-----------------------------------------------------------------------------
void InitSPI_LCD3310()
{
//	SPI1CON = 0x012B;		// Master mode, SCK = Fcy/6 = 14.74 /6=2.457 MHz  0|1011, CKP=0, CKE=1, Clk idle is low, 8 bits
	SPI1CON = 0x0123;		// Master mode, SCK = Fcy/8 = 20/8=2.5 MHz, CKP=0, CKE=1, Clk idle is low, 8 bits
	SPI1STAT = 0x8000;	// Enable SPI port
	LCD3310_Send( 0x21, LCD_CMD );  // LCD Extended Commands.
	LCD3310_Send( 0xC8, LCD_CMD );  // Set LCD Vop (Contrast).
//	LCD3310_Send( 0x80, LCD_CMD );  // Set LCD Vop (Contrast).
	LCD3310_Send( 0x06, LCD_CMD );  // Set Temp coefficent.
	LCD3310_Send( 0x13, LCD_CMD );  // LCD bias mode 1:48.
	LCD3310_Send( 0x20, LCD_CMD );  // LCD Standard Commands, Horizontal addressing mode.
	LCD3310_Send( 0x0C, LCD_CMD );  // LCD in normal mode.
//	LCD3310_Send( 0x0D, LCD_CMD );  // LCD in inverse videoe.
}
//---------------------------------------------------------------------
// Set the current position for data (x = 0->83, y = 0->5)
void LCD3310_Clear()
{
unsigned int x, y;
	for (y=0; y<6; y++)
		for (x=0; x<84; x++)
			LCD3310_Send( 0x00, LCD_DATA );		// caractre vide
}
//---------------------------------------------------------------------
// Set the current position for data (x = 0->83, y = 0->5)
void LCD3310_GotoXY(unsigned short xnokia, unsigned short ynokia)
{
	LCD3310_Send( 0x40 | ( ynokia & 0x07), LCD_CMD );		// new y cursor position
	LCD3310_Send( 0x80 | ( xnokia & 0x7f), LCD_CMD );		// new x cursor position
}
//-----------------------------------------------------------------------------
// Affiche une phrase  l'cran 
void LCD3310_SendMsg(unsigned char *dataPtr )
{
	while ( *dataPtr )
		LCD3310_WriteChar( *dataPtr++ );
}
//-----------------------------------------------------------------------------
// Affiche un caractere  l'cran 
void LCD3310_WriteChar(unsigned char ascii_code)
{ //20+ascii_code
	if (ascii_code<0x20)	return;
	LCD3310_Send( FontLookup [ascii_code-0x20][0], LCD_DATA );		// bout de char
	LCD3310_Send( FontLookup [ascii_code-0x20][1], LCD_DATA );		// bout de char
	LCD3310_Send( FontLookup [ascii_code-0x20][2], LCD_DATA );		// bout de char
	LCD3310_Send( FontLookup [ascii_code-0x20][3], LCD_DATA );		// bout de char
	LCD3310_Send( FontLookup [ascii_code-0x20][4], LCD_DATA );		// bout de char
}
//-----------------------------------------------------------------------------
// Envoie le caractere  afficher sur l'ecran
void LCD3310_Send(unsigned short data, unsigned short cd )
{
unsigned int uidummy;
	if (cd==LCD_DATA)	LCD3310_DC = 1;			// Enter Data Mode
			else					LCD3310_DC = 0;			// Enter Command Mode
	SPI1STATbits.SPIROV = 0;            // Clear overflow flag
	LCD3310_CS = 0;     // Set SPI CS pin du LCD 3310 actif
	uidummy = SPI1BUF;                    // Read buffer to avoid overflow
	SPI1BUF=data;	while (SPI1STATbits.SPITBF);	while ( !SPI1STATbits.SPIRBF);	// char
	LCD3310_CS = 1;     // Set SPI CS pin du LCD 3310 non actif
}
//-----------------------------------------------------------------------------
